;-================================================================;
;- Copyright (C) 2001 H-Peter Recktenwald, Berlin <phpr@snafu.de>
;- Read ./doc/LEGAL file for copyright information (GNU GPL)
;-
;-  file	: nasmmac.inc
;-  switch	: __NASMMAC_I
;-  created	: 08-apr-2001
;-  modified	:
;-  version	: 0.01
;-  assembler	: nasm 0.98e(!)
;-  description	: supplementary macroes
;-		:	which belong to the assembler:
;-		: _nolist, _listing_, list, jr, {A,T}MODE
;-  author	: H-Peter Recktenwald, Berlin <phpr@snafu.de>
;-  source	: -/-
;-  requires	: nasm 0.98e or later, patched vers. w/ "%xdefine"
;-================================================================;
;-

%ifndef __NASMMAC_I
%define __NASMMAC_I
%define nasmmacinc
;
;-
;- %define _nolist
;-	pre-definable macroes global listing on/off via asm-vari
;das, o groes erstaunen, spielt...
%ifndef _nolist
%define _nolist
%endif
;
;-
;- %macro list 0-*.nolist on;[nolist]
;-	useless substitute to upgraded nasm, just to preventing "errors"
%ifndef _listing_
%macro list 0-*.nolist on;[nolist]
%define _listing_ %{1}
%endm
%ifidn _nolist,.nolist
%define _listing_ on
%else
%define _listing_ off
%endif
%endif
;-
;- %imacro _message 0-*.nolist
;-	silly 'helper' to list macroes arguments by _content_
%ifidn __NASM,9821
%define _message_
%endif
%ifndef _message_
%define _message_
%imacro _message 0-*.nolist
%if %0>0
 %xdefine _msg_
 %rep %0
  %xdefine _msg_ _msg_ %{1}
  %rotate 1
 %endrep
 %error "_msg_"
%endif
%endm
%else
%imacro _message 0-*.nolist
%if %0>0
 %xdefine _msg_
 %rep %0
  %xdefine _msg_ _msg_ %{1}
  %rotate 1
 %endrep
 %message "_msg_"
%endif
%endm
%endif
;-
;- jr
;-	<jmp short>
%ifndef jr
%define jr jmp short
%endif
;-
;- disp
;-	<jcc/jmp disp [label|abs.expr]>
;-	cpl shortest branch code, backwards only.
%macro disp 1_nolist
%%d: equ $+4-(%{1})
%assign %%x %%d
%if (%%x<=0)&&(%%x>=0xFFFFFF80)
	%{00}	short %{1}
%elif (%%x>0)&&(%%x<0x80)
	%{00} short %{1}
%else
	%{00} near %{1}
%endif
%endm
;-
;- a32
;-	noop if __OPTIMIZE__ =/= __O_SPEED__, else
;-	align 32 if 8 bytes or less below a 32-byte bound, else align 4
%macro a32 0_nolist
%if __OPTIMIZE__=__O_SPEED__
%%x: equ ($$-$)&31
%if (%%x<9)&&(%%x>0)
    align 32
%else
    align 4
%endif
%endif
%endm
;-
;- alignment by opcode:
;-
;-	_align0_	; no alignment, for macro <oalign>
%define _align0_
;-	_align1_	;xchg eax,eax
%define _align1_ db 0x90
;-	_align2_	;lea eax,[eax]
%define _align2_ db 0x8D,00
;-	_align3_	;lea eax,[byte eax+0]
%define _align3_ db 0x8D,0x40,00
;-	_align4_	;lea eax,[cs:dword eax+0]
%define _align4_ db 0x2E,0x8D,0x40,00
;-	_align5p_	;cs: lea eax,[cs:dword eax+0]
%define _align5p_ db 0x2e,0x2E,0x8D,0x40,00
; ;-	_align5_	;lea bx,[byte bx+0]
; ; %define _align5_ db 0x66,0x67,0x8D,0x5F,00
;-	_align5_	;_align2_ _align3_
%define _align5_ db 0x8D,00,0x8D,0x40,00
;-	_align6_	;lea eax,[dword eax+0]
%define _align6_ db 0x8D,0x80,00,00,00,00
;-	_align7_	;lea ebx,[dword cs:ebx+0]
%define _align7_ db 0x2E,0x8D,0x9B,00,00,00,00
;-	_align8_	;_align6_ _align2_
%define _align8_ db 0x2E,0x8D,0x40,00,0x2E,0x8D,0x40,00
;-	_align9_	;_align6_ _align3_
%define _align9_ db 0x8D,0x80,00,00,00,00,0x8D,0x40,00
;-	_align10_	;_align6_ _align4_
%define _align10_ db 0x8D,0x80,00,00,00,00,0x2E,0x8D,0x40,00
;-	_align11_	;_align7_ _align4_
%define _align11_ db 0x2E,0x8D,0x9B,00,00,00,00,0x2E,0x8D,0x40,00
;-	_align12_	;_align6_ _align6_
%define _align12_ db 0x8D,0x80,00,00,00,00,0x8D,0x80,00,00,00,00
;-	_align13_	;_align6_ _align7_
%define _align13_ db 0x8D,0x80,00,00,00,00,0x2E,0x8D,0x9B,00,00,00,00
;-	_align14_	;_align7_ _align7_
%define _align14_ db 0x2E,0x8D,0x9B,00,00,00,00,0x2E,0x8D,0x9B,00,00,00,00
;-	_align15_	;_align6_ _align6_ _align3_
%define _align15_ db 0x8D,0x80,00,00,00,00,0x8D,0x80,00,00,00,00,0x8D,0x40,00
;-	_align16_	;_align7_ _align7_
%define _align(x)_ db jmp short $+(x)
;
;-	_ascall_	;seg-prefixed call, disp 4-aligned
%define _ascall_ dd 0xE82e2e2e
;-	
;-
;- oalign 0-*,	opt. %1 alignment per byte value
;-	align by neutral opcode insertion or, <jmp short (disp-2)> if disp > 15
%macro oalign 0-* 4_nolist
%%o: equ $-$$+(%{1})-1
%assign %%m (%{1})-(%%o-(%%o&(-(%{1}))))
%xdefine x %%m
%error "__LINE__ oaligned: x"
%if %%m>0
%assign %%m %%m-1
%if %%m<16
    _align %+ %%m %+ _
%else
    jmp short %%j
    times %%m-2 nop
%%j:
%endif
%endif
%ifid %{00}
%{00}:
%endif
%endm
;-
;- AMODE 0-1
;-	<%assign (var) 0/1> to addressing mode of operand %1
;-	var = one of AER(unknown), REG, TXT(string), EA(other)
%macro TMODE 1.nolist
%assign TXT 0
%assign NUM 0
%assign REG 0
%assign EA  0
%assign AER 1
%ifnum %{1}
%assign NUM 1
%elifstr %{1}
%assign TXT 1
%else
%assign REG 1
    %ifidni %{1},eax
    %elifidni %{1},ebx
    %elifidni %{1},ecx
    %elifidni %{1},edx
    %elifidni %{1},ebp
    %elifidni %{1},esi
    %elifidni %{1},edi
    %elifidni %{1},esp
%ifndef __LIB4TH
%elifndef __E4TH
%else
    %elifidni %{1},PS
    %elifidni %{1},RS
    %elifidni %{1},BP
    %elifidni %{1},IP
    %elifidni %{1},UP
%endif
    %else
%assign REG 0
%assign EA  1
    %endif
%endif
%endm
%macro AMODE 0-*_nolist
%if %0>0
    TMODE {%{1}}
%else
    TMODE {%{00}}
%endif
%endm
;-
;- label: min 2, %macro
;-	%xdefine %00 to the lesser of two args
%macro min 2.nolist
%xdefine %00 %{1}
%if %{1} > %{2}
%xdefine %00 %{2}
%endif
%endm
;%message 1:%{1} 2:%{2} "=>" %00
;- label: max 2, %macro
;-	%xdefine %00 to the greater of two args
%macro max 2.nolist
%xdefine %00 %{1}
%if %{1} < %{2}
%xdefine %00 %{2}
%endif
%endm
;%message 1:%{1} 2:%{2} "=>" %00
;%macro min 2
;%if (%{1})<=(%{2})
;%assign %00 (%{1})
;%else
;%assign %00 (%{2})
;%endif
;%endm
; - %macro max 2
;%macro max 2
;%if (%{1})>=(%{2})
;%assign %{00} (%{1})
;%else
;%assign %{00} (%{2})
;%endif
;%endm
;-
%endif ;__NASMMAC_I
;-
;-================================================================;
;- nasmmac.inc <eof>
